// 
//   Script to flag parts 200000 and above, put them in a set, and move them. 
//

//   Assume we are working with Model 1

var m = Model.GetFromID(1);

//   Pick part                  

var p = Part.Pick("Pick a rigid part",m);

// Check the part is rigid and the user did not press Cancel

if (!p) Exit();
if (!p.rigid)
{
   var answer = Window.Warning("Error","Part is not rigid",Window.OK);
   Exit();
}

//   Pick node                  

var n = Node.Pick("Pick a node",m);

//   Create the data in a temporary file and import

f = new File("./ibtmp.key", File.WRITE);     // Open temporary file
f.Writeln("*KEYWORD");                       // Write keyword data to file
f.Writeln("*CONSTRAINED_EXTRA_NODES_NODE");
f.Writeln(NumberToString(p.pid,10) + NumberToString(n.nid,10));
f.Writeln("*END");
f.Close();                                   // Close temporary file
m.Import("ibtmp.key");                       // Import data from file into model

//   Redraw the new model and exit //

m.UpdateGraphics();
Exit();
