// 
//   Script to select parts, put them in a set, and move them. 
//
//   Select a model (if only one model is present, it will be
//   selected automatically)

var m = Model.Select("Select a model");

//   Add code to allocate and clear a flag

var my_flag = AllocateFlag();
m.ClearFlag(my_flag);

//   Pick parts                  

var num_selected = 0;

Part.Select(my_flag, "Select parts to move")

// Add code to call to a new function CountSelectedParts whose return value
//  is num_selected. The function will need model m and my_flag as input, 
//  these are global variables so they do not have to passed via the 
//  argument list

var num_selected = CountSelectedParts(my_flag);

Message("Number of selected parts = " + num_selected);

//   Create a set

//   Find the first free set ID (starting from 10001)

var set_id = 10001;
while(Set.GetFromID(m, set_id, Set.PART)) set_id++;
 
//   Add code to create the part set using ID set_id, and 
//       add the flagged parts to it
var s = new Set(m, set_id, Set.PART);
s.AddFlagged(my_flag);

//   Propagate flag

m.PropagateFlag(my_flag);

//   Loop through all the nodes

var n = Node.First(m);
while (n)
{
//   (Add code to increase x-coord by 1000 if node is flagged)
   if (n.Flagged(my_flag)) n.x = n.x + 1000.0;
   n = n.Next();
}
//   Perform a model check
DialogueInput("/CHECK MODEL 1 CHECKFILE check_results.txt APPLY");

//   Redraw the new model and exit //

m.UpdateGraphics();
View.Ac();
Exit();

//  This is the coding that should go inside the new function CountSelectedParts
//  You have to make this coding into a function, with return value num_selected
//  The flag input_flag should be an input argument

function CountSelectedParts(input_flag)
{
   var p = Part.First(m);
   while (p)            
   {
      if (p.Flagged(input_flag))
      {
         Message("Selected part " + p.pid);             
         num_selected++;
      }
      p = p.Next();
   }
   return num_selected;
}
