// 
//   Script to pick a part and move it
//

//   Assume we are working with Model 1

var m = Model.GetFromID(1);

//   Allocate and clear a flag

var my_flag = AllocateFlag();
m.ClearFlag(my_flag);

//   Pick a part                  
var p = Part.Pick("Pick a part to move",m);

//   Exit if the user pressed Cancel
if (!p) 
{
   ReturnFlag(my_flag);
   Exit();
}

//   Flag the picked part
p.SetFlag(my_flag);

//   Propagate flag
m.PropagateFlag(my_flag);

//   Loop through all the nodes

var n = Node.First(m);
while (n)
{
//   Increase x-coord by 1000 if node is flagged
   if (n.Flagged(my_flag)) n.x = n.x + 1000.0;
   n = n.Next();
}

//   Return the flag
ReturnFlag(my_flag);

//   Redraw the new model and exit //

m.UpdateGraphics();
View.Ac();
Exit();
