// 
//   Script to pick a part and move it
//

//   Assume we are working with Model 1

var m = Model.GetFromID(1);

//   Add code to check that model m exists. If not, use Window.Error
//   to tell the user and then Exit when they press OK.
if (!m) 
{
   Window.Error("Error","Error - Model 1 does not exist",Window.OK);
   Exit();
}

//   Allocate and clear a flag

var my_flag = AllocateFlag();
m.ClearFlag(my_flag);

//   Pick a part                  
var p = Part.Pick("Pick a part to move",m);

//   Exit if the user pressed Cancel
if (!p) 
{
   ReturnFlag(my_flag);
   Exit();
}

//   Add code here: use Window.Question to check whether the 
//   user wants to move the picked part. Offer the choice of
//   "Yes" or "No". If the answer is "no", exit.
var answer = Window.Question("Question","Do you want to move Part " + p.pid +"?", Window.YES | Window.NO);
if (answer == Window.NO) 
{
   ReturnFlag(my_flag);
   Exit();
}

//   Flag the picked part
p.SetFlag(my_flag);

//   Propagate flag
m.PropagateFlag(my_flag);

//   Loop through all the nodes

var n = Node.First(m);
while (n)
{
//   Increase x-coord by 1000 if node is flagged
   if (n.Flagged(my_flag)) n.x = n.x + 1000.0;
   n = n.Next();
}

//   Return the flag
ReturnFlag(my_flag);

//   Redraw the new model and exit //

m.UpdateGraphics();
View.Ac();
Exit();
