// 
//   Script to read nodes from a csv file      
//

//   Create a model 

var m = new Model();

//   Open the file nodes.csv

var filename = Window.GetFilename("Select file", "CSV file?", "csv");
if (filename == null) Exit();

var f = new File(filename, File.READ);

var line;
var words = new Array();

//   The first line contains column headers - skip it
line =  f.ReadLine();

//   Keep reading lines from the file until there are no more
//   For each line, echo it to the dialog box

while ( (line = f.ReadLine()) != undefined )
{
   words = line.split(",");
   num_words = words.length;
   Message("Found " + num_words + " words");
   if (num_words == 4)
   {
       Message("label   = " + words[0]);
       Message("x-coord = " + words[1]);
       Message("y-coord = " + words[2]);
       Message("z-coord = " + words[3]);
       
// Get the node label from the first word                   
       var label = parseInt(words[0]);

// Parse node x coordinate
       var x = parseFloat(words[1]);

// Parse node y coordinate
       var y = parseFloat(words[2]);

// Parse node z coordinate
       var z = parseFloat(words[3]);

// Create node
       var n = new Node(m,label,x,y,z);
   }
}

//  Close the file
f.Close();

//   Print x-coordinate of first node
var n1 = Node.First(m);
var node1 = n1.nid;
Message ("Node label and x-coordinate: " + node1 + ", " + n1.x);

//   Loop through nodes, printing labels and incrementing x-coord
while(n1)
{
   Message("Node label = " + n1.nid);
   n1.x = n1.x + 100.0;
   n1 = n1.Next();
}

//   Loop through nodes, incrementing y-coord
var n1 = Node.First(m);
while(n1)
{
   Message("Node label = " + n1.nid);
   n1.y = n1.y + 100.0;
   n1 = n1.Next();
}
   
//   Get all nodes into an array

var nodes = Node.GetAll(m);

//   Create a shell element using the 1st, 2nd, 13th and 12th node
var s = new Shell(m,1001,100,nodes[0].nid,nodes[1].nid,nodes[12].nid,nodes[11].nid);

CreateMoreShells();

//   Turn on node visibility, draw the new model and exit //

Visibility("Node", true);
m.UpdateGraphics();
View.Show(View.XY);
View.Ac();
Exit();

function CreateMoreShells()
{
   var s = new Shell(m,   1, 100,1077,1078,1067,1066);
   var s = new Shell(m,   2, 100,1055,1066,1067,1056);
   var s = new Shell(m,   3, 100,1055,1044,1045,1056);
   var s = new Shell(m,   4, 100,1044,1033,1034,1045);
   var s = new Shell(m,   5, 100,1057,1068,1067,1056);
   var s = new Shell(m,   6, 100,1034,1045,1046,1035);
   var s = new Shell(m,   7, 100,1088,1077,1078,1089);
   var s = new Shell(m,   8, 100,1078,1089,1090,1079);
   var s = new Shell(m,   9, 100,1040,1051,1052,1041);
   var s = new Shell(m,  10, 100,1051,1052,1063,1062);
   var s = new Shell(m,  11, 100,1062,1063,1074,1073);
   var s = new Shell(m,  12, 100,1084,1073,1074,1085);
   var s = new Shell(m,  13, 100,1095,1084,1085,1096);
   var s = new Shell(m,  17, 100,1065,1064,1075,1076);
   var s = new Shell(m,  19, 100,1080,1091,1092,1081);
   var s = new Shell(m,  20, 100,1069,1080,1081,1070);
   var s = new Shell(m,  21, 100,1058,1069,1070,1059);
   var s = new Shell(m,  22, 100,1047,1058,1059,1048);
   var s = new Shell(m,  23, 100,1037,1048,1047,1036);
   var s = new Shell(m,  24, 100,1094,1093,1082,1083);
   var s = new Shell(m,  25, 100,1072,1071,1082,1083);
   var s = new Shell(m,  26, 100,1061,1060,1071,1072);
   var s = new Shell(m,  27, 100,1050,1049,1060,1061);
   var s = new Shell(m,  28, 100,1039,1038,1049,1050);
   var s = new Shell(m,  29, 100,1091,1038,1039,1092);
   var s = new Shell(m,  30, 100,1085,1075,1076,1096);
   var s = new Shell(m,  31, 100,1052,1064,1065,1041);
   var s = new Shell(m,  32, 100,1110,1099,1100,1111);
   var s = new Shell(m,  33, 100,1108,1119,1120,1109);
   var s = new Shell(m,  34, 100,1009,1010,1021,1020);
}
