// 
//   Script to select parts, put them in a set, and move them. 
//

//   Select a model (if only one model is present, it will be
//   selected automatically)

var m = Model.Select("Select a model");

//   Write part data to csv file using DialogueInput

DialogueInput("/PART_INFO write data.csv " + m.number);

//   Add code to allocate and clear a flag

var my_flag = AllocateFlag();
m.ClearFlag(my_flag);

//   Pick parts                  

var num_selected = 0;

Part.Select(my_flag, "Select parts to move");

var p = Part.First(m);
while (p)            
{
   if (p.Flagged(my_flag))
   {
      Message("Selected part " + p.pid);             
      num_selected++;
   }
   p = p.Next();
}

Message("Number of selected parts = " + num_selected);

//
//   Find the first free set ID (starting from 10001)

var set_id = 10001;
while(Set.GetFromID(m, set_id, Set.PART)) set_id++;
 
//   Add code to create the part set using ID set_id, and 
//       add the flagged parts to it
var s = new Set(m, set_id, Set.PART);
s.AddFlagged(my_flag);

//   Propagate flag

m.PropagateFlag(my_flag);

//   Loop through all the nodes

var n = Node.First(m);
while (n)
{
//   (Add code to increase x-coord by 1000 if node is flagged)
   if (n.Flagged(my_flag)) n.x = n.x + 1000.0;
   n = n.Next();
}

//   Redraw the new model and exit //

m.UpdateGraphics();
View.Ac();
Exit();
