// 
//  Javascript to find maximum Von Mises stress in any shell at any time
//

SetCurrentModel(1);                // Assume we are working with Model 1
var nshell  = GetNumberOf(SHELL);  // Find number of shells in model
var nstate = GetNumberOf(STATE);   // Get number of time-states in results file

var smax = 0.0;                    // Initialize variable for max stress

//  Loop through states

for (istate=1; istate<=nstate; istate++)   
{
   SetCurrentState(istate);
   Message("...processing state " + istate);

//  Loop through shells, finding stress

   for (j=1; j<=nshell; j++)
   {
      var svm1 = GetData(SVON, SHELL, j, TOP);
      var svm2 = GetData(SVON, SHELL, j, MIDDLE);
      var svm3 = GetData(SVON, SHELL, j, BOTTOM);

      smax = Math.max(smax,svm1,svm2,svm3);
   }

//  Next state
}

//  Report the result to dialog box and exit
Message("Maximum stress = " + smax);
Exit();
