// 
//  Javascript to calculate failure index                                
//

SetCurrentModel(1);                // Assume we are working with Model 1
var nshell  = GetNumberOf(SHELL);  // Find number of shells in model
var nstate = GetNumberOf(STATE);   // Get number of time-states in results file

var smax = 0.0;                    // Initialize variable for max stress

//  Create UBIN component for failure index
icomp = CreateUbinComponent("Failure index", U_SOSH, U_SCALAR, REPLACE);

//  Loop through states
for (istate=1; istate<=nstate; istate++) 
{
   SetCurrentState(istate);
   Message("...processing state " + istate);

//  Loop through shells, finding stress
   for (j=1; j<=nshell; j++)
   {
      var fail = 0.0;
      for (isurf=1; isurf<4; isurf++)   // Check top, middle and bottom surfaces
      {
         var svm = GetData(SVON, SHELL, j, isurf);
         var epl = GetData(EPL,  SHELL, j, isurf);
         var test = svm/200.;
         if (epl > 0.0) test = 1.0 + epl/0.8;
         fail = Math.max (fail,test);
      }
      PutUbinData(icomp, SHELL, j, 1, fail);
   }

//  Next state
}

Exit();
