// 
//  Javascript to calculate failure index                                
//

SetCurrentModel(1);                // Assume we are working with Model 1
var nshell  = GetNumberOf(SHELL);  // Find number of shells in model
var nstate = GetNumberOf(STATE);   // Get number of time-states in results file

var smax = 0.0;                    // Initialize variable for max stress

//  Create UBIN component for failure index

// (add your code here to create a data component named "Failure index";
//    this should be a Scalar data component for solids/shells)

//  Loop through states
for (istate=1; istate<=nstate; istate++) 
{
   SetCurrentState(istate);
   Message("...processing state " + istate);

//  Loop through shells, calculating failure index
   for (j=1; j<=nshell; j++)
   {
      var fail = 0.0;
      for (isurf=1; isurf<4; isurf++)   // Check top, middle and bottom surfaces
      {
         var svm = GetData(SVON, SHELL, j, isurf);
         var epl = GetData(EPL,  SHELL, j, isurf);
         var test = svm/200.;
         if (epl > 0.0) test = 1.0 + epl/0.8;
         fail = Math.max (fail,test);
      }
//   Write failure index to UBIN data component
      
//    (add your code here to write the value fail to your data component 
//     for shell j)

   }

//  Next state
}

Exit();
