// 
//  Javascript to create vector data of horizontal displacement
//

SetCurrentModel(1);                // Assume we are working with Model 1
var nnode  = GetNumberOf(NODE);    // Find number of nodes in model
var nstate = GetNumberOf(STATE);   // Get number of time-states in results file

//  Create data component

icomp = CreateUbinComponent("My vector" , U_NODE, U_VECTOR, REPLACE); 
var my_result = new Array();

//////////////////////////////////////////////////////////////////////////
//
//  Now we can calculate current horizontal displacement as a percentage 
//  of the maximum
//
//  Loop through states

for (istate=1; istate<=nstate; istate++)   
{
   SetCurrentState(istate);
   Message("...processing state " + istate);

//  Loop through nodes, calculating displacement as a percentage

   for (j=1; j<=nnode; j++)
   {
      my_result[0] = GetData(DX, NODE, j);
      my_result[1] = GetData(DY, NODE, j);
      my_result[2] = 0.0;                   
      PutUbinData(icomp, NODE, j, 0, my_result);    // store data for plotting 
   }

//  Next state
}

Exit();
