// 
//  Javascript to find maximum displacement of any node at any time
//

SetCurrentModel(1);                // Assume we are working with Model 1
var nnode  = GetNumberOf(NODE);    // Find number of nodes in model
var nstate = GetNumberOf(STATE);   // Get number of time-states in results file

var dmax = 0.0;                    // Initialize variable for max displacement

//  Loop through states

for (istate=1; istate<=nstate; istate++)   
{
   SetCurrentState(istate);
   Message("...processing state " + istate);

//  Loop through nodes, finding max displacement

   for (j=1; j<=nnode; j++)
   {
      var dx1 = GetData(DX, NODE, j);
      var dy1 = GetData(DY, NODE, j);
      var dz1 = GetData(DZ, NODE, j);
      var disp = Math.sqrt(dx1*dx1 + dy1*dy1 + dz1*dz1);
      dmax = Math.max(dmax,disp);
   }

//  Next state
}

//  Report the result to dialog box and exit
Message("Maximum displacement = " + dmax);
Exit();
